#!/usr/bin/perl
use strict;
use Cwd;

open(LOG,">.install.log");

my $tmp_dir = "/tmp/vs_osd_package";
my $install_dir = "/usr/share/vs_osd";
my @out;
my $startdir = getcwd();
my $package = $startdir . "/install_touch_controller.tgz";
my $tmp_dir = "/tmp/vs_osd_package";
my $line;

@out = `rm -rf $tmp_dir` if -d $tmp_dir; $line = __LINE__;
checkresult(0);

@out = `mkdir $tmp_dir`; $line = __LINE__;
checkresult(0);

@out = `rm -rf $install_dir` if -d $install_dir; $line = __LINE__;
checkresult(0);

@out = `mkdir $install_dir`; $line = __LINE__;
checkresult(0);

chdir($install_dir);

@out = `mkdir qt`; $line = __LINE__;
checkresult(0);
#@out = `mkdir qt/plugins`; $line = __LINE__;
#checkresult(0);
#@out = `mkdir qt/plugins/platforms`; $line = __LINE__;
#checkresult(0);

chdir($tmp_dir);

@out = `tar -xzf $package`; $line = __LINE__;
checkresult(0);


@out = `tar -xf package.tar`; $line = __LINE__;
checkresult(0);

@out = `cp TouchController $install_dir`; $line = __LINE__;
checkresult(0);

@out = `cp vs_osd.png $install_dir`; $line = __LINE__;
checkresult(0);

@out = `cp qt.conf $install_dir`; $line = __LINE__;
checkresult(0);

@out = `mkdir qt`; $line = __LINE__;
checkresult(0);

chdir("qt");
@out = `tar -xf $tmp_dir/qt.tar`; $line = __LINE__;
checkresult(0);

my @files = <*>;
foreach my $file (@files) {
#print $file . "\n";
#print "/usr/lib/x86_64-linux-gnu/" . $file . "\n";
  if(not -e "/usr/lib/x86_64-linux-gnu/" . $file)
  {
    my $cmd = "cp -r $file $install_dir/qt";
#    print $cmd . "\n";
    @out = `$cmd`;
    checkresult(0);
  }
}

`cp libQt5* $install_dir/qt`;
#`cp -r libqxcb* $install_dir/qt`;

#chdir($install_dir);
#@out = `mkdir qt`; $line = __LINE__;
#checkresult(0);





my $is_ubuntu=0;
if(-e "/etc/lsb-release")
{
  my @lines = `grep -i DISTRIB_ID=Ubuntu /etc/lsb-release`;
  my $lines = @lines;
  if($lines >= 1)
  {
    $is_ubuntu = 1;
  }
}

my $is_fedora=0;
if(-e "/etc/fedora-release")
{
  my @lines = `grep -i fedora /etc/fedora-release`;
  my $lines = @lines;
  if($lines >= 1)
  {
    $is_fedora = 1;
  }
}

if($is_ubuntu)
{
  system("apt-get install ddcci-dkms -y 1>/dev/null 2>/dev/null");
  system("apt-get install read-edid -y 1>/dev/null 2>/dev/null");
  system("apt-get install libpcre2-16-0 -y 1>/dev/null 2>/dev/null");
  system("modprobe ddcci 1>/dev/null 2>/dev/null");
}

if($is_fedora)
{ ## use built in Qt on Fedora
  print "Installing packages; please wait\n";
  @out = `rm -rf $install_dir/qt`; $line = __LINE__;
  @out = `rm -rf $install_dir/qt.conf`; $line = __LINE__;

 # system("yum -y install git make \"kernel-devel-uname-r == \$(uname -r)\" 1>/dev/null 2>/dev/null");
  system("yum -y install git make kernel-devel.x86_64 cmake gcc-c++ libx86-devel.x86_64 1>/dev/null 2>/dev/null");

  chdir($tmp_dir);

  print "Getting driver package; please wait\n";
  @out = `git clone https://gitlab.com/ddcci-driver-linux/ddcci-driver-linux.git`; $line = __LINE__;
  checkresult(0);

  print "Building driver; please wait\n";
  chdir($tmp_dir . "/ddcci-driver-linux");

  @out = `make`; $line = __LINE__;
  checkresult(0);

  @out = `make install`; $line = __LINE__;
  checkresult(0);

  @out = `make load`; $line = __LINE__;
  checkresult(0);

  print "Building edid interface; please wait\n";
  chdir($tmp_dir);
  @out = `wget http://www.polypux.org/projects/read-edid/read-edid-3.0.2.tar.gz`; $line = __LINE__;
  checkresult(0);
  @out = `tar -xzvf read-edid-3.0.2.tar.gz`; $line = __LINE__;
  checkresult(0);
  chdir('read-edid-3.0.2');
  system("sed \"s:int quiet:extern int quiet:\" < \"get-edid/i2c.c\" > \"get-edid/i2c.tmp\"");
  @out = `cp ./get-edid/i2c.tmp get-edid/i2c.c`; $line = __LINE__;
  checkresult(0);
  @out = `cmake . -DCLASSICBUILD=OFF`; $line = __LINE__;
  checkresult(0);
  @out = `make`; $line = __LINE__;
  checkresult(0);
  @out = `cp ./get-edid/get-edid /usr/bin`; $line = __LINE__;
  checkresult(0);


  system("modprobe ddcci 1>/dev/null 2>/dev/null");
}

chdir($tmp_dir);

@out = `cp TouchController.desktop /usr/share/applications`; $line = __LINE__;
checkresult(0);


print "\n\n*********************************************************\n";
print "The Touch Controller software was installed successfully!\n";
print "*********************************************************\n\n";

if(!$is_ubuntu && !$is_fedora)
{
  print "Use your system's package manager to locate and update the components ddcci-dkms, read-edid\n";
}

sub getrc
{
  my $rc = $? >>  8;
  return($rc);
}

sub checkresult
{
  my $rc = getrc();

  print LOG @out;

nolog:
  if($rc > $_[0])
  {
    die "failed with rc=$rc  at line $line\n\n"
  }
}

EOF:
